% ressort06.m
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
title ('Integration d un double oscillateur harmonique amorti') ;
tmax=4*pi 
n=10*tmax
dt=.1
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ; 
kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
xx = [ 1 1 1 ]' ;

t=zeros(1,n+1);
x=zeros(3,n+1);
y=zeros(3,n+1); 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
for i=1:n;
t(i+1)=t(i)+dt;
end ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
end ;
xmax=tmax+.1
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
plot(t(1,:) , x(1:1,:), '*;;' , t(1,:) , x(2:2,:), '*b;;'  , \
 t(1,:) , x(3:3,:), '*g;;' ,  t(1,:) , mm1*x(1:1,:) + mm2*x(2:2,:) + mm3*x(3:3,:) , '*m;;' ) ; 








